;******** Write Element Name At Bottom *********;
;Kinda self-explanatory name, but this Macro	;
;puts the current element name at the bottom of	;
;the screen. Called once every iteration of the	;
;main loop.							;
;***********************************************;
WriteElementNameAtBottom MACRO
 bsr		SetFontNormal				;Set the font to normal size
 bsr		CalcCellSpecial				;Calculate the current cell and put the offset to the selected element in d3
 lea		TheData(pc),a0				;Load the address of the Periodic Data into a0
 move.w	#4,-(a7)					;Push a 4 (color of text)
 pea		elementname(a0,d3)			;Push the name of the current element
 move.w	#92,-(a7)					;y
 move.w	#52,-(a7)					;x
 ROM_CALL DrawStr			;Draw that text at that position
 lea		10(a7),a7					;Add 10 to the stack to return stack to normal
 ENDM


;************** Center On Element **************;
;This macro finds the element whose number in	;
;d0.b and places it on the screen. Only used	;
;after the Browse Names or Browse Symbols.	;
;***********************************************;
CenterOnElement MACRO
 clr.w	d0						;We don't want any extraneous data to mess it up.
 move.b	(cnum),d0					;Move the selected menu itme # into d0
 move.b	0(a0,d0.w),d0				;Using the menu lookup-table (a0), we get the element # into d0
 lea		LookUpTable(pc),a0			;Load the address of the REAL lookuptable (the one that contains layout)
 move.w	#180,d1					;Loop 180 times
LoopLTable:
 subq.w	#1,d1						;Subtract one
 cmp.b	0(a0,d1.w),d0				;Check that element
 bne		LoopLTable					;If that is not it, loop back around
 clr.l	d0						;clear d0
 move.w	d1,d0						;Put the element # into d0
 divu		#18,d0					;d0 = row
 move.w	d0,d2						;Put the row # in d2
 mulu		#18,d2					;Multiply the row by 18
 sub.w	d2,d1						;d1 = column #
 move.w	d0,(TableY)
 subq.w	#3,(TableY)
 tst.w	(TableY)
 bge		NotTooLowY
 clr.w	(TableY)
NotTooLowY:
 cmp.w	#5,(TableY)
 blt		NotTooBigY
 move.w	#4,(TableY)
NotTooBigY:
 move.w	d1,(TableX)
 subq.w	#5,(TableX)
 tst.w	(TableX)
 bge		NotTooLowX
 clr.w	(TableX)
NotTooLowX:
 cmp.w	#8,(TableX)
 blt		NotTooBigX
 move.w	#7,(TableX)
NotTooBigX:
 sub.w	(TableX),d1
 move.w	d1,(ActiveOffsX)
 sub.w	(TableY),d0
 move.w	d0,(ActiveOffsY)
 clr.w	d0
 ENDM


;************ Browse Symbols *************;
;This macro displays a menu of the symbols;
;of every element in the periodc table.	;
;The first line of the macro must be	;
;adjusted if you intend to add elements to;
;the periodic table. Otherwise, you will	;
;write to memory you have not allocated.	;
;*****************************************; 
BrowseSymbols MACRO
 move.l	#354,-(a7)				;110 elements * 3 bytes/element symbol = 330 + 24 = 354 bytes
 ROM_CALL HeapAlloc		;Attempt to allocate 354 bytes of RAM. d0 = * mem or 0 on failure
 addq.w	#4,a7
 tst.w	d0					;If the memory didn't allocate correctly,
 beq		exitBrowseSymbols			;then exit this macro.
 move.w	d0,handle1num			;Move the pointer to the memeory into d0?
 move.w	d0,-(a7)
 ROM_CALL HeapDeref
 addq.w	#2,a7
; ROM_CALL DEREF d0,a1				;a1 points to the allocated memory. Don't forget to free when you're done with it.
 move.l	a0,a3					;Copy the address of the allocated mem to a3
 move.b 	#109,0(a0)				;109 menu items.
 lea		Menu3Title(pc),a1			;Load the address of what we want to move into a0
 adda.l	#20,a1				;Add 20 to it because we're copying it backwards.
 moveq 	#19,d0				;We want to move 20 elements in Menu3Title, so we loop 20 times.
\MoveTitle:
 move.b	-(a1),1(a0,d0)			;Copy one byte
 dbra		d0,\MoveTitle			;Deincrement and loop till d0 = -1
 move.b	#3,21(a0)				;Each menu item is 3 bytes long
 adda.l	#22,a0				;Update the address of a1 so we don't have to keep copying with a big # in front of the parentheses (i.e. 72(a1))
 lea		TheData(pc),a1			;Load the address of the data into a0
 lea		Menu3Sort(pc),a2			;Load the address of Menu3Sort into a2
 moveq	#109,d5				;Loop 110 times (# of elements + 1)
SRepeatMoveNames:
 clr.l	d4					;Clear d4
 move.b	(a2),d4				;Move the current element # in Menu3Sort to d4
 subq.b	#1,d4					;Subtract one from it
 mulu		#DataOffset,d4			;Multiply it by the size of one element's data
 move.b	0(a1,d4),(a0)+			;Copy the periodic symbol
 move.b	1(a1,d4),(a0)+
 move.b	2(a1,d4),(a0)+
 addq.l	#1,a2					;Add 1 to the element #
 dbra		d5,SRepeatMoveNames
 pea		Menu3Shortcuts(pc)
 pea		(a3)
 bsr		Menu
 addq.w	#8,a7
 move.w	handle1num,-(a7)					;This little snippet of code
 ROM_CALL HeapFree					;clears the heap that was
 addq.l	#2,a7					;allocated for the Symbols menu
 clr.w	handle1num
exitBrowseSymbols:
 ENDM

;************* Browse Names **************;
;This macro displays a menu of the names	;
;of every element in the periodc table.	;
;The first line of the macro must be	;
;adjusted if you intend to add elements to;
;the periodic table. Otherwise, you will	;
;write to memory you have not allocated.	;
;*****************************************;
BrowseNames MACRO
 move.l	#1454,-(a7)				;110 elements * 13 bytes/element name = 1430 + 24 = 1454
 ROM_CALL HeapAlloc
 addq.l	#4,a7
 tst.w	d0
 beq		exitBrowseNames
 move.w 	d0,handle1num
 move.w	d0,-(a7)
 ROM_CALL HeapDeref
 addq.l	#2,a7
; ROM_CALL DEREF d0,a1	;a1=pointer to the mem.!
 move.b 	#109,0(a0)
 moveq 	#19,d0
 lea		Menu2Title(pc),a1
 adda.l	#20,a1
RepeatMoveTitle:
 move.b 	-(a1),1(a0,d0)
 dbra		d0,RepeatMoveTitle
 move.b	#13,21(a0)

 move.l	a0,a3

 moveq	#109,d5
 adda.l	#22,a0
 lea		TheData(pc),a1
 lea		Menu2Sort(pc),a2
RepeatMoveNames:
 moveq	#12,d1
 clr.l	d4
 move.b	(a2),d4
 subq.b	#1,d4
 mulu		#DataOffset,d4
 addq.w	#3,d4
 addq.l	#1,a2
RepeatMoveName:
 move.b 	0(a1,d4),(a0)+
 addq.w	#1,d4
 dbra		d1,RepeatMoveName
 dbra		d5,RepeatMoveNames
 pea		Menu2Shortcuts(pc)
 pea		(a3)
 bsr		Menu
 addq.l	#8,a7
 move.w	handle1num,-(a7)					;This little snippet of code
 ROM_CALL HeapFree					;clears the heap that was
 addq.l	#2,a7					;allocated for this menu
 clr.w	handle1num
exitBrowseNames:
 ENDM


;*************** Show Info ***************;
;This macro displays the information about;
;the element selected when the ENTER key	;
;is pressed. For information on what each ;
;part of the data presented means, look in;
;README.txt.					;
;Things to do:					;
;	Implement more efficient DrawStr that	;
;	that just changes x/y when they NEED it ;
;*****************************************;
ShowInfo MACRO
 bsr		CalcCellSpecial
 move.w	#160,(xoffs)		;put 160 into xoffs
 clr.w	(yoffs)			;put 0 into yoffs
 lea		tmpstring(pc),a0		;load the address of tmpstring into a0
 clr.w	d1
 bsr		NumToStr			;put the atomic number into a string
 move.w	d3,d7
 move.l	a0,a4
 bsr		DrawBack			;draw the square (including the atomic number)
 move.w	d7,d3
 lea		TheData(pc),a0		;load the address of the periodic data table into a0

 bsr		SetFontSmall	
 lea		0(a0,d3),a4
 move.l	a0,a1				;copy the address of the data table into a0
 move.w	#4,-(a7)			;put a 4 onto the stack
 pea		0(a4)				;push the address of the symbol

 move.w 	#2,-(a7)			;y
 move.w 	#176,-(a7)			;x
 ROM_CALL DrawStr	;Symbol
 addq.l	#8,a7
 
 pea		elementname(a4)		;push the address of the name of the element

 move.w	#2,-(a7)			;y
 move.w	#189,-(a7)			;x
 ROM_CALL DrawStr	;draw the name of the element
 addq.l	#8,a7
 
;Display The Mass
 clr.l	d1
 move.l	mass(a4),d0			;the mass
 move.b	4+mass(a4),d1		;the comma position for the mass
 lea		tmpstring(pc),a0
 bsr		NumToStr
 pea		(a0)
 move.w	#28,-(a7)			;y
 move.w	#200,-(a7)			;x
 ROM_CALL DrawStr 
 addq.l	#8,a7

 clr.w	d0
 move.b	elementtype(a4),d0
 subq.w	#1,d0
 mulu		#22,d0
 lea		ETypes(pc),a0

 pea		0(a0,d0.w)
 move.w	#20,-(a7)			;y
 move.w	#162,-(a7)			;x
 ROM_CALL DrawStr	;Type
 addq.l	#8,a7

;Display The Mass string
 pea		MassStr(pc)
 move.w	#28,-(a7)			;y
 move.w	#162,-(a7)			;x
 ROM_CALL DrawStr	
 addq.l	#8,a7

 pea		PressAKeyStr(pc)

 move.w	#74,-(a7)			;y
 move.w	#171,-(a7)			;x
 ROM_CALL DrawStr 
 addq.l	#8,a7

 pea		MeltingStr(pc)

 move.w	#36,-(a7)			;y
 move.w	#162,-(a7)			;x
 ROM_CALL DrawStr
 addq.l	#8,a7
 
 pea		BoilingStr(pc)

 move.w	#42,-(a7)			;y
 move.w 	#162,-(a7)			;x
 ROM_CALL DrawStr 
 addq.l	#8,a7

 pea		IonizeStr(pc)

 move.w	#50,-(a7)			;y
 move.w	#162,-(a7)			;x
 ROM_CALL DrawStr 
 addq.l	#8,a7
 
 pea		ElectroStr(pc)

 move.w	#56,-(a7)			;y
 move.w	#162,-(a7)			;x
 ROM_CALL DrawStr 
 addq.l	#8,a7

 move.b	electroneg(a4),d0
 moveq	#1,d1
 lea		tmpstring(pc),a0
 bsr		NumToStr
 tst.b	electroneg(a4)
 bne		ElectroOk
 lea		NotAvail(pc),a0
ElectroOk:
 pea		(a0)
 move.w	#56,-(a7)			;y
 move.w	#200,-(a7)			;x
 ROM_CALL DrawStr	;Electro
 addq.l	#8,a7

 move.b	ionenergy(a4),d0
 moveq	#1,d1
 lea		tmpstring(pc),a0
 bsr		NumToStr
 tst.b	ionenergy(a4)
 bne		IonOk
 lea		NotAvail(pc),a0
IonOk:

 pea		(a0)
 move.w	#50,-(a7)			;y
 move.w 	#200,-(a7)			;x
 ROM_CALL DrawStr	;Ion
 addq.l	#8,a7


 move.w	boiling(a4),d0
 move.b	boilingcomma(a4),d1
 lea		tmpstring(pc),a0
 bsr		NumToStr
 tst.w	boiling(a4)
 bne    	BoilOk
 lea		NotAvail(pc),a0
BoilOk:

 pea		(a0)
 move.w	#42,-(a7)			;y
 move.w	#200,-(a7)			;x
 ROM_CALL DrawStr	;Boiling
 addq.l	#8,a7

 move.w	melting(a4),d0
 move.b	meltingcomma(a4),d1
 lea		tmpstring(pc),a0
 bsr		NumToStr
 tst.w	melting(a4)
 bne		MeltOk
 lea		NotAvail(pc),a0
MeltOk:

 pea		(a0)
 move.w 	#36,-(a7)			;y
 move.w 	#200,-(a7)			;x
 ROM_CALL DrawStr	;Melting
 addq.l	#8,a7
 DispOxidation
;Electron Configuration
 DispElectronConfig
 addq.l	#2,a7				;This is to complete all the DrawStr's. This is the 4 that is common to ALL of them

 move.w	#1,-(a7)
 move.w	#9,-(a7)
 move.w	#239,-(a7)
 move.w	#9,-(a7)
 move.w	#160,-(a7)
 ROM_CALL DrawLine
 move.w #72,6(a7)
 move.w #72,2(a7)
 ROM_CALL DrawLine
 lea	10(a7),a7

 move.w	#40,(xoffs)
 move.w	#7,(yoffs)
 bsr		ScaleUp
 ROM_CALL ngetchx

; movem.l	(a7)+,d0-d7/a0-a4
 ENDM


;************** Display Oxidation **************;
;This sub-macro of ShowInfo writes the oxidation;
;of the current element on the screen.		;
;***********************************************;
DispOxidation MACRO
 moveq	#43,d6				;43 is the ASCII value for '+'
 move.w	#162,d5				;d5 = x position to start drawing to
 move.b	posoxidation(a4),d7		;load the positive oxidation numbers (1 byte) into d7
PlusMinusLoop:
 moveq	#7,d4					;Bit to test
Loop8:
 lea		tmpstring(pc),a0
 btst.b	d4,d7					;Test the current bit (chosen by d4) of d7
 beq		OxidationIsZero			;If it's zero, then don't write anything
 move.b	d4,d1					;Copy the bit to test to d1
 move.b 	d6,0(a0)				;Either a '+' or a '-'
 add.b	#49,d1				;Convert the # to it's ASCII value. (turn into string)
 move.b	d1,1(a0)				;Move the # into the second byte of the string
 clr.b	2(a0)					;Delete the third byte so that it looks like a 2 byte string instead of a 10 byte string
 pea		(a0)					;Push the address of the string
 move.w	#64,-(a7)				;y
 move.w	d5,-(a7)				;x
 ROM_CALL DrawStr 		Draw the string
 addq.w	#8,a7					;Return the stack to position before DrawStr so as to not cause an Address Error :-P
 add.w	#9,d5					;Add 9 to the x position so that the program doesn't write to the same place every time.
OxidationIsZero:
 dbra		d4,Loop8				;Loop back to test the next lower bit
 cmp.w	#43,d6				;Are we still on '+' oxidation's?
 bne		DoneWithOxidation			;If not, then we're done with writing out the oxidation
 moveq	#45,d6				;If we are still on '+', time to start on '-'
 move.b	negoxidation(a4),d7		;Load the negative oxidations
 bra		PlusMinusLoop			;And loop back to the beginning
DoneWithOxidation:
 ENDM


;******** Display Electron Configuration *******;
;This sub-macro of the ShowInfo macro displays	;
;the electron configuration of the current	;
;element. You shouldn't ever have to change this;
;routine. THAT MEANS YOU, PAUL (talking to	;
;myself).							;
;***********************************************;
DispElectronConfig MACRO
 clr.l	d6
 clr.l	d3					;Added by Paul
 lea		tmpstring(pc),a2
 move.w	(ActiveOffsY),d0			;Calculate the current row
 add.w	(TableY),d0				;and put it in d0
 move.w	d0,d4					;Copy that number to d4
 tst.w	d0					;Are we in the first row?
 bne		\NotSpecialAlign			;If not, then you don't need to specially align it for lack of [Xe] type thing
 moveq	#17,d6				;
 bra		\NoBase				;Skip ahead because there is no base for these electron configs in the first row
\NotSpecialAlign:
 subq.w	#1,d0					;Subtract one from the column number
 cmp.w	#7,d0					;is it 7?
 bne		\NotLanthanide			;If not, then we aren't in the Lanthanides, so skip ahead
 moveq	#4,d0					;Pretend we are in the 5th row
 moveq	#5,d4					;Pretend we are in the 5th row
\NotLanthanide
 cmp.w	#8,d0					;Are we in the 8th row
 bne		\NotActinide			;If not, we're not in the Actinides, so skip ahead
 moveq	#5,d0					;Pretend we are in the 6th row
 moveq	#6,d4					;Pretend we are in the 6th row
\NotActinide:
 lsl.w	#2,d0					;Multiply the row # by 4 (the size of an entry in EL_Bases
 lea		EL_Bases(pc),a0			;Load the Electron Bases into a0 for copying
 adda.w	d0,a0					;Load the address of the correct electron base into a0
 move.b	(a0)+,0(a2)				;Copy the correct electron base into tmpstring
 move.b	(a0)+,1(a2)				;Same as above
 move.b	(a0)+,2(a2)				;Same as above
 move.b	(a0)+,3(a2)				;Same as above
 clr.b	4(a2)					;Null-terminate the string

; move.w	#4,-(a7)				;Color
 pea		(a2)					;Address of the string
 move.w	#13,-(a7)				;y
 move.w	#162,-(a7)				;x
 ROM_CALL DrawStr		;Draw the string
; lea		10(a7),a7				;Return the stack from drawing the string
 addq.w	#8,a7
\NoBase:
 lea		EL_Levels(pc),a3			;Load the address of the electron levels into a3
 lsl.w	#3,d4					;Multiply the row # by 8
 adda		d4,a3					;Correct the address pointing to Electron Levels to point to the correct one
 clr.w	d5					;Clear d5
 move.w	#179,d4				;Variable used to keep track of where to write the current part of the electron configuration.
 sub.w	d6,d4					;Take the difference between 
\LoopEC:
 clr.w	d0					;Clear d0 because we'll be multipling a byte out of it's range
 move.b	electronconfig(a4,d3),d0	;Put the current byte of the electron config into d0
 tst.b	d0					;Is it zero?
 beq		\EmptyShell				;If so, we have an empty shell, so skip writing anything for this one
 move.w	d5,d2					;Move the current element of the config (1-4)
 lsl.w	#1,d2					;Multiply that by 2
 move.b	0(a3,d2.w),0(a2)			;Copy the two letters
 move.b	1(a3,d2.w),1(a2)
 clr.b	2(a2)
; move.w	#4,-(a7)
 pea		(a2)
 move.w	#13,-(a7)				;y
 move.w	d4,-(a7)				;x
 ROM_CALL DrawStr
 addq.w	#8,a7
; lea		10(a7),a7
 move.b	electronconfig(a4,d3),d0
 clr.b	d1
 lea		tmpstring(pc),a0
 bsr		NumToStr
 addq.w	#8,d4
 move.w	#4,-(a7)
 pea		(a0)
 move.w	#11,-(a7)				;y
 move.w	d4,-(a7)				;x
 ROM_CALL DrawStr
 lea		10(a7),a7

 move.b	electronconfig(a4,d3),d0
 cmp.b	#10,d0
 blt		\NotExtraSpace
 addq.w	#4,d4
\NotExtraSpace:
 addq.w	#5,d4
\EmptyShell:
 addq.w	#1,d3
 addq.w	#1,d5
 cmp.w	#4,d5
 bne		\LoopEC
 ENDM
